#ifndef HASHMAP_H
#define HASHMAP_H

#include <stdint.h>

#define ARRAY_SIZE 16
#define STRING_LEN 256

typedef char V[STRING_LEN];
typedef char K[STRING_LEN];

struct hashmap_entry_t {
  struct hashmap_entry_t *next;
  V value;
  K key;
  uint32_t hash;
};


struct hashmap_t {
  struct hashmap_entry_t* entries[ARRAY_SIZE];
};

void hashmap_init(struct hashmap_t *hashmap);

void hashmap_finalize(struct hashmap_t *hashmap);

void hashmap_put(struct hashmap_t *hashmap, K key, V value);

int hashmap_get(struct hashmap_t *hashmap, K key, V value);


#endif	/* HASHMAP_H */
